#ifndef gui_HPP
#define gui_HPP

#include<iostream>

#include"rinex.hpp"
#include"procesamientoRinex.hpp"


#include<wx/wx.h>
#include<wx/button.h>
#include<wx/toolbar.h>
#include<wx/tbarbase.h>
#include<wx/statbox.h>
#include<wx/validate.h>
#include<wx/string.h>
#include<wx/dirdlg.h>
#include<wx/image.h>
#include<wx/stattext.h>
#include<wx/statline.h>

using namespace std;

class Aplicacion : public wxApp
{
public:
  virtual bool OnInit();

};


class Ventana : public wxFrame
{
public:
  Ventana(const wxString& tituloVentana);
  virtual ~Ventana();

  //Declaracion de los botones en los menus
  void BotonSalida(wxCommandEvent& evento);
  void BotonAyuda(wxCommandEvent& evento);
  void BotonInformacion(wxCommandEvent& evento);

  //Delcaracion de los botones para buscar los archivos de la base
  void BotonCargueObservacionesBaseRinex(wxCommandEvent& evento);
  void BotonCargueNavegacionesBaseRinex(wxCommandEvent& evento);
  void BotonCargueMetereologiaBaseRinex(wxCommandEvent& evento);

  //Delcaracion de los botones para buscar los archivos del rover
  void BotonCargueObservacionesRoverRinex(wxCommandEvent& evento);
  void BotonCargueNavegacionesRoverRinex(wxCommandEvent& evento);
  void BotonCargueMetereologiaRoverRinex(wxCommandEvent& evento);

  //Declaracion del boton para guardar el reporte
  void BotonGuardarReporte(wxCommandEvent& evento);

  //Declaraciones de los botones dentro de la barra de herramientas
  void BotonProcesar(wxCommandEvent& evento);
  void DialogoSalidaDatos();
private:

  DECLARE_EVENT_TABLE();

  //Cadenas de caracteres
  wxString nombreArchivo;
  wxString mensajes;

  //Cajas de texto de la ruta de los archivos RINEX de la base
  wxTextCtrl *aptCtrlTextoCoordenadaXBase;
  wxTextCtrl *aptCtrlTextoCoordenadaYBase;
  wxTextCtrl *aptCtrlTextoCoordenadaZBase;



  //Cajas de texto de la ruta de los archivos RINEX de la base
  wxTextCtrl *aptCtrlTextoObservacionesBaseRinex;
  wxTextCtrl *aptCtrlTextoNavegacionesBaseRinex;
  wxTextCtrl *aptCtrlTextoMetereologiaBaseRinex;


  //Cajas de texto de la ruta de los archivos RINEX del rover
  wxTextCtrl *aptCtrlTextoObservacionesRoverRinex;
  wxTextCtrl *aptCtrlTextoNavegacionesRoverRinex;
  wxTextCtrl *aptCtrlTextoMetereologiaRoverRinex;

  //Botones para buscar los Archivos RINEX de la base
  wxButton *aptBotonObsBaseRinex;
  wxButton *aptBotonNavBaseRinex;
  wxButton *aptBotonMetBaseRinex;


  //Botones para buscar los Archivos RINEX de la base
  wxButton *aptBotonObsRoverRinex;
  wxButton *aptBotonNavRoverRinex;
  wxButton *aptBotonMetRoverRinex;


  //Caja de texto para la ruta del reporte
  wxTextCtrl *aptCtrlTextoArchivoSalida;

  //boton relacionado con la selección de la ruta de almacenamiento del archivo de salida
  wxButton *aptBotonArchivoSalida;

  //boton asociado con el procesamiento de los archivos
  wxButton *aptBotonProcesamiento;


  Rinex *archivosRinexBase;
  Rinex *archivosRinexRover;

  double xBase, yBase, xRover, yRover, zBase, zRover;

  //Tipo de archivo base o rover
  int x;

  //Instanciacion del objeto ProcesamientoRinex
  //el cual procesa los datos cargador en el objeto Rinex
  ProcesamientoRinex ajusteCoordenadas;

  //Variables tipo wxString con datos de la Base
  wxString coordenadaXBase;
  wxString coordenadaYBase;
  wxString coordenadaZBase;
  wxString latitudBase;
  wxString longitudBase;
  wxString alturaBase;
  
  //Varibles tipo wxString con datos del Rover
  wxString coordenadaXRover;
  wxString coordenadaYRover;
  wxString coordenadaZRover;
  wxString latitudRover;
  wxString longitudRover;
  wxString alturaRover;
  
  //Vector
  wxString longitudVector;

  wxDialog *salidaDatos;
  wxDialog *salidaInfo;
}; 

class DialogoDatos : public wxDialog
{
  DialogoDatos(const wxString &);
};


#endif
